SystemOrganization addCategory: #ConwaysLife!

Object subclass: #ConwaysCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConwaysLife'!

ConwaysCell subclass: #DeadCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConwaysLife'!

!DeadCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 13:31'!
color

	^Color white.! !

!DeadCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/14/2012 22:15'!
liveOrDieGivenThatYouHaveThisAmountOfLivingNeighbours: anAmount

	(anAmount =3 ) ifTrue:[^LivingCell new] ifFalse:[^self] ! !

!DeadCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 01:21'!
returnOneIfAliveElseReturnCero

	^0.! !

ConwaysCell subclass: #LivingCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConwaysLife'!

!LivingCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 13:55'!
color

	^Color black.

	! !

!LivingCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/14/2012 22:11'!
liveOrDieGivenThatYouHaveThisAmountOfLivingNeighbours: anAmount

	((anAmount = 2) or: (anAmount =3 )) ifTrue:[^self] ifFalse:[^DeadCell new] 

	! !

!LivingCell methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 01:22'!
returnOneIfAliveElseReturnCero

	^1.

	! !

Object subclass: #ConwaysLifeGame
	instanceVariableNames: 'positionsToCells positionsToNumberOfLivingNeighbours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConwaysLife'!

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 01:27'!
at:aPosition put:aCell

positionsToCells at: aPosition put: aCell.
	! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 14:13'!
drawGame
	
	|cellDrawing |

	positionsToCells keysAndValuesDo: [ :position : cell | cellDrawing := (Morph new color: (cell color)). cellDrawing position: (position x * 20 @ position y * 20). cellDrawing openInWorld.  ]. ! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/14/2012 22:27'!
initialize 

positionsToCells:= Dictionary new.
positionsToNumberOfLivingNeighbours:= Dictionary new.! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 02:01'!
numberOfLivingNeighboursForThisPosition: aPosition

	|x y allNeigboursPositions allX allY result|
	
	result:= 0.
	
	x:= aPosition x.
	y:= aPosition y.
	
	allNeigboursPositions := Bag new.
	allX :=Bag new.
	allY := Bag new.
	
	allX add: x.
	allX add: (x-1).
	allX add: (x+1).
	
	allY add: y.
	allY add: (y-1).
	allY add: (y+1).
	
	
	allX do: [ 
		
		:currentX|  allY do: 
		
	
	[:currentY|  (positionsToCells includesKey: (currentX@currentY)) ifTrue:[ result := result +   (positionsToCells at: (currentX@currentY)) returnOneIfAliveElseReturnCero ]].
	 ].
	result := result - ((positionsToCells at: aPosition) returnOneIfAliveElseReturnCero).
	
	^result.! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 01:25'!
positionsToNumberOfLivingNeighbours

	^positionsToNumberOfLivingNeighbours.
	! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 02:03'!
updateCells

	self updatePositionsToNumberOfLivingNeighbours.
	
	self updatePositionsToCells.
	! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/15/2012 02:14'!
updatePositionsToCells

	(positionsToNumberOfLivingNeighbours keys) do: [  :position |  positionsToCells at: position put: ((positionsToCells at:position) 
		liveOrDieGivenThatYouHaveThisAmountOfLivingNeighbours: (positionsToNumberOfLivingNeighbours at: position)) ]! !

!ConwaysLifeGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/14/2012 22:35'!
updatePositionsToNumberOfLivingNeighbours

	(positionsToCells keys) do: [ :position | positionsToNumberOfLivingNeighbours at: position put: (self numberOfLivingNeighboursForThisPosition: position)]! !
